import callApi from './callApi'
import start from './start'
import stop from './stop'
import fetchUpdate from './fetchUpdate'
import fetchUserInfo from './fetchUserInfo'
import fetchGameInfo from './fetchGameInfo'
import collectQuotes from './collectQuotes'
import startGame from './startGame'
import resetGame from './resetGame'
import continueGame from './continueGame'
import finishGame from './finishGame'
import parseSyncData from './parseSyncData'
import saveSelection from './saveSelection'
import getMyQuotes from './getMyQuotes'
import saveQuote from './saveQuote'
import createQuote from './createQuote'
import removeQuote from './removeQuote'

export default (context, inject) => {
  const engine = {
    context,
    lastFetched: [0, 0, 0, 0, 0],
    isActive: false,
    shouldStop: false,

    callApi,
    start,
    stop,
    fetchUpdate,
    fetchUserInfo,
    fetchGameInfo,
    collectQuotes,
    getMyQuotes,
    saveQuote,
    createQuote,
    removeQuote,
    startGame,
    resetGame,
    continueGame,
    finishGame,
    parseSyncData,
    saveSelection,
  }

  inject('engine', engine)
}
