package application

import (
	"encoding/json"
	"os"
	"path"
	"sirlab.de/go/knyt/game"
)

func (app *Application) saveGameState(gm *game.Game) error {
	gameJson := gm.GetGameState()
	jsonString, errMarshal := json.MarshalIndent(gameJson, "", "  ")
	if errMarshal != nil {
		return errMarshal
	}

	dirName := path.Join(app.config.DataDir, "games", gm.GetId())
	f, err := os.CreateTemp(dirName, "state.tmp-*.json")
	if err != nil {
		return err
	}
	defer os.Remove(f.Name())

	if _, err := f.Write(jsonString); err != nil {
		return err
	}
	if err := f.Close(); err != nil {
		return err
	}

	fileName := path.Join(dirName, "state.json")
	if err := os.Rename(f.Name(), fileName); err != nil {
		return err
	}

	return nil
}
