package game

import (
	"sirlab.de/go/knyt/syncdata"
)

func (gm *Game) populateSyncDataCb(syncData *syncdata.SyncData) {
	syncData.GameInfo = gm.populateGameInfo()
}

func (gm *Game) populateGameInfo() syncdata.GameInfo {
	numQuotesLeft, numQuotesTotal := gm.countQuotes()

	gm.mu.Lock()
	defer gm.mu.Unlock()

	return syncdata.GameInfo{
		GameId:         gm.id,
		Name:           gm.name,
		State:          gm.state,
		Phase:          gm.phase,
		Players:        gm.populateGetPlayers(),
		Round:          gm.populateGetRoundInfo(),
		NumQuotesLeft:  numQuotesLeft,
		NumQuotesTotal: numQuotesTotal,
	}
}

func (gm *Game) countQuotes() (int, int) {
	allQuotes := gm.getAllQuotes()
	numQuotesLeft := 0

	for _, q := range allQuotes {
		if !q.IsPlayed() {
			numQuotesLeft++
		}
	}

	return numQuotesLeft, len(allQuotes)
}
